VERSION 5.00
Begin VB.Form Form1 
   Caption         =   "Form1"
   ClientHeight    =   5295
   ClientLeft      =   60
   ClientTop       =   345
   ClientWidth     =   8115
   LinkTopic       =   "Form1"
   ScaleHeight     =   5295
   ScaleWidth      =   8115
   StartUpPosition =   3  'Windows Default
   Begin VB.CommandButton Command1 
      Caption         =   "Command1"
      Height          =   1125
      Left            =   4830
      TabIndex        =   8
      Top             =   3495
      Width           =   2025
   End
   Begin VB.CommandButton cmdEnd 
      Caption         =   "End"
      Height          =   450
      Left            =   5295
      TabIndex        =   7
      Top             =   2355
      Width           =   825
   End
   Begin VB.CommandButton cmdFileProperties 
      Caption         =   "File Properties"
      Height          =   525
      Left            =   5205
      TabIndex        =   6
      Top             =   1575
      Width           =   1020
   End
   Begin VB.CommandButton cmdFolderProperties 
      Caption         =   "Folder Properties"
      Height          =   495
      Left            =   5115
      TabIndex        =   5
      Top             =   840
      Width           =   1110
   End
   Begin VB.CommandButton cmdDriveProperties 
      Caption         =   "Properties"
      Height          =   540
      Left            =   5115
      TabIndex        =   4
      Top             =   180
      Width           =   1170
   End
   Begin VB.ListBox FolderList 
      Height          =   2790
      Left            =   240
      Sorted          =   -1  'True
      TabIndex        =   3
      Top             =   1485
      Width           =   1965
   End
   Begin VB.ListBox FilesList 
      Height          =   2790
      Left            =   2430
      Sorted          =   -1  'True
      TabIndex        =   2
      Top             =   1470
      Width           =   2115
   End
   Begin VB.DriveListBox Drive1 
      Height          =   315
      Left            =   255
      TabIndex        =   1
      Top             =   735
      Width           =   2085
   End
   Begin VB.Label lbCurrPath 
      Caption         =   "Label1"
      Height          =   270
      Left            =   240
      TabIndex        =   0
      Top             =   195
      Width           =   5280
   End
End
Attribute VB_Name = "Form1"
Attribute VB_GlobalNameSpace = False
Attribute VB_Creatable = False
Attribute VB_PredeclaredId = True
Attribute VB_Exposed = False
Option Explicit

Private Sub Command1_Click()

  ChDir "C:\"
 
End Sub

Private Sub Form_Load()

   Me.Move (Screen.Width - Me.Width) \ 2, (Screen.Height - Me.Height) \ 2
   LoadFolderInfo
  
End Sub


Private Sub cmdEnd_Click()
   
   Unload Me
   
End Sub


Private Sub cmdFileProperties_Click()
   
  'pass the selected item.  Bracketing the list item assures
  'that the text is passed, rather than the list property.
   ShowProperties (FilesList.List(FilesList.ListIndex))

End Sub


Private Sub cmdFolderProperties_Click()

   ShowProperties (FolderList.List(FolderList.ListIndex))

End Sub


Private Sub cmdDriveProperties_Click()

   ShowProperties (Drive1.List(Drive1.ListIndex))
    
End Sub


Private Sub Drive1_Change()
   
  'trap a drive not ready error
   On Local Error GoTo Drive1_Error
   
  'change to the selected drive
   ChDrive Drive1.Drive
   
  'get the info
   LoadFolderInfo
     
Exit Sub
     
Drive1_Error:

   MsgBox "The selected drive is not ready.", _
           vbCritical, "File and Property Demo"
    
End Sub


Private Sub FilesList_Click()
   
  'only enable the properies button if both an item is
  'selected, and that item is not the 'no files' message
   cmdFileProperties.Enabled = (FilesList.ListIndex > -1) And _
        (FilesList.List(FilesList.ListIndex)) <> ""

End Sub


Private Sub FilesList_DblClick()
   
  'add double-click fuctionality
   ShowProperties (FilesList.List(FilesList.ListIndex))

End Sub


Private Sub FolderList_Click()

    cmdFolderProperties.Enabled = (FolderList.ListIndex > -1)

End Sub


Private Sub FolderList_DblClick()

  'add double-click fuctionality
   Dim newPath As String
   
   newPath = Trim$(FolderList.List(FolderList.ListIndex))
   
  'Required to validate the path
   If Right$(CurDir, 1) <> "\" Then
          ChDir CurDir + "\" + newPath
    Else: ChDir CurDir + newPath
    End If
   
  'Get items for the new folder
   LoadFolderInfo
    
End Sub


Private Function TrimNull(item As String)
   
  'Return a string without the chr$(0) terminator.
   Dim pos As Integer

   pos = InStr(item, Chr$(0))
    
   If pos Then
         TrimNull = Left$(item, pos - 1)
   Else: TrimNull = item
   End If


End Function


Private Sub ShowProperties(filename As String)
    
   Dim SEI As SHELLEXECUTEINFO
   Dim r As Long
    
   With SEI
      .cbSize = Len(SEI)
      .fMask = SEE_MASK_NOCLOSEPROCESS Or SEE_MASK_INVOKEIDLIST Or SEE_MASK_FLAG_NO_UI
      .hwnd = Me.hwnd
      .lpVerb = "properties"
      .lpFile = filename
      .lpParameters = vbNullChar
      .lpDirectory = vbNullChar
      .nShow = 0
      .hInstApp = 0
      .lpIDList = 0
   End With
    
   r = ShellExecuteEX(SEI)
    
End Sub


Private Sub LoadFolderInfo()
    
  'Display the contents of a drive/folder.

   Dim hFile As Long
   Dim fname As String
   Dim WFD As WIN32_FIND_DATA
    
   lbCurrPath.Caption = " Reading files and directories...."
   FilesList.Clear
   FolderList.Clear
   cmdFileProperties.Enabled = False
   cmdFolderProperties.Enabled = False
   
  'Get the first file in the directory (it will usually return ".")
   hFile = FindFirstFile("*.*" & Chr$(0), WFD)
   
  'If nothing returned, bail out.
   If hFile < 0 Then Exit Sub

   Do
 
     'list the directories in the FolderList.
      If (WFD.dwFileAttributes And vbDirectory) Then
           
        'strip the trailing chr$(0) and add to the folder list.
         FolderList.AddItem TrimNull(WFD.cFileName)
    
      Else
           
         'strip the trailing chr$(0) and add to the file list.
          FilesList.AddItem TrimNull(WFD.cFileName)
    
      End If
      
    
   Loop While FindNextFile(hFile, WFD)
    
  'Close the search handle
   Call FindClose(hFile)
   
  'update both the current path label and the filelist
   If FilesList.ListCount = 0 Then FilesList.AddItem ""
   lbCurrPath.Caption = CurDir
   
End Sub
'--end block--'
   



